local Character = require 'game.world.characters.character'

local HC = require 'libs.HC'
local g = love.graphics
local k = love.keyboard

local Player = {}
Player.__index = Player

setmetatable(Player, { __index = Character })

function Player.create(collider)
    local self = Character.create()
    setmetatable(self, Player)
    self.collider = collider
    self.shape = self.collider:rectangle(self.x, self.y, 20, 32)
    return self
end

function Player:update(dt)
    local x, y = self.shape:center()
    if k.isDown("right") then
        self.vx = 100
    elseif k.isDown("left") then
        self.vx = -100
    else
        self.vx = 0
    end
    -- Gravity
    self.vy = 100
    for shape, delta in pairs(self.collider:collisions(self.shape)) do
        -- print(delta.x, delta.y)
        if delta.y < 0 then
            self.vy = 0
        end
        --[[local slope = delta.x / delta.y
        self.vx = self.vx + (slope) * 50
        self.vy = self.vy + (-slope) * self.vx]]--
    end
    x = x + self.vx * dt
    y = y + self.vy * dt
    self:setPosition(x, y)
end

function Player:draw()
    local x, y = self.shape:center()
    g.rectangle("fill", x - 10, y - 16, 20, 32)

    g.print("Pos: "..x.." "..y, x, y - 32)
end

function Player:setPosition(x, y)
    self.shape:moveTo(x, y)
end

function Player:getPosition()
    return self.shape:center()
end

return Player
