local g = love.graphics

--constants
local TILE_S = 16

local camera = require 'game.render.camera'
local Map = require 'game.render.map'
local Player = require 'game.world.characters.player'

local map
local player

local k = love.keyboard

local windowWidth, windowHeight = g.getDimensions()

function love.load(args)
    map = Map.create()
    map:load('res/map/main.lua')
    player = Player.create(map:getCollider())
    local spawn = map:getSpawnPoint()
    player:setPosition(spawn.x, spawn.y)
end

function love.update(dt)
    dt = math.min(1/60, dt)
    if k.isDown("p") then
        return
    end
    map:update(dt)
    player:update(dt)
    camera:focus(player, map)
end

function love.draw()
    camera:set()

    map:draw(0, 0, windowWidth, windowHeight)
    player:draw()

    camera:unset()
end
